/************************************************************/
/*                                                          */
/* File:    snapdll.h                                       */
/* Author:  F.Senders (Frits@Cyberdude.com)                 */
/*          the Netherlands                                 */
/* Date:    30/09/2001                                      */
/*                                                          */
/************************************************************/

#include <system.hpp>

#ifndef SNAPDLLH

#define SNAPDLLH

// typedefs:

typedef  unsigned __int8   BYTE;

typedef  BYTE  Type_DataBytes[512];

typedef struct{
   BYTE	major;
   BYTE	minor;
} Type_Version;

typedef struct{
   __int32  DestAdd;
   __int32  SourceAdd;
   Type_DataBytes Data;
   __int16  NumOfDataBytes;
   BYTE     EDMByte;
   BYTE     ACKBits;
   BYTE     CMDBit;
   TDateTime RXTime;
} Type_RXData;

typedef struct{
   __int32  DestAdd;
   Type_DataBytes Data;
   __int16  NumOfDataBytes;
   BYTE     EDMByte ;
   BYTE     ACKBits;
   BYTE     CMDBit;
} Type_TXData;

typedef  BYTE  Type_PacketBytes[1042];

typedef struct{
   __int16  NumOfBytes;
   Type_PacketBytes  PacketBytes;
   TDateTime Time;
} Type_Packet;

typedef struct{
   __int32  RejectedPackets;
   __int32  TransmittedPackets;
   __int32  ReceivedPackets;
   __int32  TotalPackets;
   __int32  RejectedBytes;
   __int32  TransmittedBytes;
   __int32  ReceivedBytes;
   __int32  TotalBytes;
   TDateTime StartTime;
} Type_Statistics;

// prototypes:

extern "C" Type_Version _stdcall DLLVersion( void);
extern "C" void __stdcall SetMyAddress( __int32 Address);
extern "C" __int32 __stdcall MyAddress( void);
extern "C" __int16 __stdcall SendData( Type_TXData *pTXData);
extern "C" void __stdcall GetTXPacket( Type_Packet *pPacket);
extern "C" __int16 __stdcall RXByteIn( BYTE InByte);
extern "C" __int16 __stdcall GetRXData( Type_RXData *pRXData);
extern "C" void __stdcall GetStatistics( Type_Statistics *pStat);
extern "C" void __stdcall ClearStatistics( void);
extern "C" __int16 __stdcall GetSPYData( Type_RXData *pRXData);


#endif
