VERSION 4.00
Begin VB.Form Form1 
   Appearance      =   0  'Flat
   BackColor       =   &H00C0C0C0&
   Caption         =   "S.N.A.P BasicRx"
   ClientHeight    =   3075
   ClientLeft      =   4560
   ClientTop       =   3960
   ClientWidth     =   4965
   FillColor       =   &H00C0C0C0&
   BeginProperty Font 
      name            =   "Arial"
      charset         =   0
      weight          =   700
      size            =   12
      underline       =   0   'False
      italic          =   0   'False
      strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H00000000&
   Height          =   3480
   Left            =   4500
   LinkTopic       =   "Form1"
   ScaleHeight     =   3075
   ScaleWidth      =   4965
   Top             =   3615
   Width           =   5085
   Begin VB.TextBox TxtReceive 
      BeginProperty Font 
         name            =   "Fixedsys"
         charset         =   0
         weight          =   400
         size            =   9
         underline       =   0   'False
         italic          =   0   'False
         strikethrough   =   0   'False
      EndProperty
      Height          =   1815
      Left            =   360
      MultiLine       =   -1  'True
      TabIndex        =   0
      Top             =   600
      Width           =   4215
   End
   Begin VB.Timer RxTimer 
      Interval        =   200
      Left            =   840
      Top             =   2520
   End
   Begin MSCommLib.MSComm SerialPort 
      Left            =   120
      Top             =   2520
      _Version        =   65536
      _ExtentX        =   847
      _ExtentY        =   847
      _StockProps     =   0
      CDTimeout       =   0
      CommPort        =   1
      CTSTimeout      =   0
      DSRTimeout      =   0
      DTREnable       =   0   'False
      Handshaking     =   0
      InBufferSize    =   1024
      InputLen        =   1
      Interval        =   1000
      NullDiscard     =   0   'False
      OutBufferSize   =   512
      ParityReplace   =   "?"
      RThreshold      =   1
      RTSEnable       =   0   'False
      Settings        =   "9600,n,8,1"
      SThreshold      =   0
   End
End
Attribute VB_Name = "Form1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
'
' Version 1.02 av BasicRx - 991230 by HTH
'
' This minimal example shows how to receive a S.N.A.P packet on the serialport.
'
' Experienced programmers that want to take full advantage of the SNAP.DLL
' and implement functions like statistics, spying on other network traffic
' etc. see other examples in the ZIP-file.
'
' You can download the complete protocol description in PDF-format at
' the following URL...
'
'   http://www.hth.com/snap/
'
' More information about PLM-24 Power Line Modem and related products
' is available at...
'
'   http://www.hth.com/plm-24/
'
' Feel free to e-mail us any comments at info@hth.com. Due to the amount
' of e-mails we receive we are not always able to reply to you personally
' but all comments about the DLL or S.N.A.P network protocol in general
' are read and all feedback is appreciated!
'
' Disclaimer
' ----------
'
' This is released as "AS IS" and we are not able to provide any free
' support.
'
' Copyright (c) 1999 HTH all rights reserved
'
' Visual Basic 4.00
'
' External OCX/DLL files
'
' Name         Version       Maker
' ------------------------------------
' MSCOMM32.OCX  1.00        Microsoft
' SNAP.DLL      1.10        Harry Zachrisson, HTH
'

'Declaration
Private Declare Sub SetMyAddress Lib "snap.dll" (ByVal Address As Integer)
Private Declare Function RXByteIn Lib "snap.dll" (ByVal InByte As Byte) As Boolean
Private Declare Function GetRXData Lib "snap.dll" (RXData As Type_RXData) As Boolean

'Constants
Const MAXDATASIZE = 512

'Definitions of data records used by SNAP.DLL

'Declaration of a DataBytes structure
Private Type Type_DataBytes
    Byt(1 To MAXDATASIZE) As Byte
End Type

'Declaration of a RXData structure
'This is the received data from the RX packet decoder (GetRXData)
Private Type Type_RXData
    DestAdd As Long             '-1=No Destination address was used. 0=Broadcast
    SourceAdd As Long           '-1=No Source address was used. 0=Broadcast
    Data As Type_DataBytes      'Data
    NumOfDataBytes As Integer   'How many bytes in the Data array that is used
    EDMBits As Byte             'Only bits 0-3 is used, nice to have.
    ACKBits As Byte             'Only bits 0-3 is used, indicates if it was an ACK response
    CMDBit As Byte              'Only bit 0 is used, indicates if command mode is enabled/disabled
    RXTime As Date              'Time stamp of Inpacket
End Type

'Variables
Dim Rx As Type_RXData
Dim Data As Type_DataBytes

Private Sub Form_Load()

    'Enable error trap for comport
    On Error GoTo Porterror
    
    'Settings for comport where PLM-24 is attached
    SerialPort.CommPort = 1                'Change if needed
    SerialPort.Settings = "2400,N,8,1"     '300 - 2400 bps for PLM-24
    SerialPort.Handshaking = 0
    SerialPort.InputLen = 1
    SerialPort.RThreshold = 1
    SerialPort.DTREnable = False
    SerialPort.RTSEnable = False
    SerialPort.PortOpen = True

    'Assign source address
    SetMyAddress 1

    Exit Sub
    
Porterror:
    'Comport error handler
    Const ERR_DEVICEUNAVAILABLE = 68
    If (Err = ERR_DEVICEUNAVAILABLE) Then
        Msg = "No contact with COM-Port " & Str(SerialPort.CommPort)
        MsgBox Msg, 48
        Exit Sub
    Else
        Msg = "Unexpected error #" & Str(Err) & " occured: " & Error
        MsgBox Msg, 16
        Stop
    End If
    Resume
End Sub

Private Sub Form_Unload(Cancel As Integer)
    SerialPort.PortOpen = False
    End
End Sub


Private Sub RxTimer_Timer()

    'This timer polls the inbuffer in SNAP.DLL. If there is any
    'decoded S.N.A.P packets addressed to you (equals MyAddress or
    'address 0 that is the broadcast address) available it will
    'show it in the TxtReceive window. It will continue to do so
    'until the inbuffer is empty.
    
    While GetRXData(Rx)
        Beep
        'Show decoded S.N.A.P packet in TxtReceive
        TxtReceive.Text = " Source Address........: " & Rx.SourceAdd & Chr$(13) & Chr$(10)
        TxtReceive.Text = TxtReceive.Text & " Destination Address...: " & Rx.DestAdd & Chr$(13) & Chr$(10)
        TxtReceive.Text = TxtReceive.Text & " Number of Databytes...: " & Rx.NumOfDataBytes & Chr$(13) & Chr$(10)
        TxtReceive.Text = TxtReceive.Text & " Data Byte value (DB1).: " & Rx.Data.Byt(1) & Chr$(13) & Chr$(10)
        TxtReceive.Text = TxtReceive.Text & " Error detection method: " & Rx.EDMBits & Chr$(13) & Chr$(10)
        TxtReceive.Text = TxtReceive.Text & " ACK/NAK...............: " & Rx.ACKBits & Chr$(13) & Chr$(10)
        TxtReceive.Text = TxtReceive.Text & " Command mode bit......: " & Rx.CMDBit & Chr$(13) & Chr$(10)
        TxtReceive.Text = TxtReceive.Text & " Time received.........: " & Format(Rx.RXTime, "hh:mm:ss")
    Wend
    
End Sub

Private Sub SerialPort_OnComm()

    Dim EVMsg$
    Dim ERMsg$
    
    'Event messages
    Select Case SerialPort.CommEvent
        'Trigged when PLM-24 Power Line Modem receives data
        Case comEvReceive
                If SerialPort.InBufferCount <> 0 Then
                    'Convert the received character to byte value and pass it to the DLL
                    Dummy = RXByteIn(AscB(SerialPort.Input))
                End If
        'Trigged if any comport errors ocurrs
        Case ComErBreak
            EVMsg$ = "Break Received"
        Case ComErCTSTO
            ERMsg$ = "CTS Timeout"
        Case ComErDSRTO
            ERMsg$ = "DSR Timeout"
        Case ComErFrame
            EVMsg$ = "Framing Error"
        Case ComErOverrun
            ERMsg$ = "Overrun Error"
        Case ComErCDTO
            ERMsg$ = "Carrier Detect Timeout"
        Case ComErRxOver
            ERMsg$ = "Receive Buffer Overflow"
        Case ComErRxParity
            EVMsg$ = "Parity Error"
        Case ComErTxFull
            ERMsg$ = "Transmit Buffer Full"
        Case Else
            ERMsg$ = "Unknown error or event"
    End Select
    
    'Check if any comport errors occured.
    If Len(EVMsg$) <> 0 Then
        Debug.Print EVMsg$
    End If
End Sub

