VERSION 4.00
Begin VB.Form Form1 
   Appearance      =   0  'Flat
   BackColor       =   &H00C0C0C0&
   Caption         =   "S.N.A.P BasicTx"
   ClientHeight    =   2400
   ClientLeft      =   5160
   ClientTop       =   4335
   ClientWidth     =   3390
   FillColor       =   &H00C0C0C0&
   BeginProperty Font 
      name            =   "Arial"
      charset         =   0
      weight          =   700
      size            =   12
      underline       =   0   'False
      italic          =   0   'False
      strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H00000000&
   Height          =   2805
   Left            =   5100
   LinkTopic       =   "Form1"
   ScaleHeight     =   2400
   ScaleWidth      =   3390
   Top             =   3990
   Width           =   3510
   Begin VB.Timer TxTimer 
      Interval        =   200
      Left            =   960
      Top             =   1680
   End
   Begin VB.CommandButton CmdSend 
      Caption         =   "Send"
      BeginProperty Font 
         name            =   "System"
         charset         =   0
         weight          =   700
         size            =   9.75
         underline       =   0   'False
         italic          =   0   'False
         strikethrough   =   0   'False
      EndProperty
      Height          =   615
      Left            =   720
      TabIndex        =   0
      Top             =   840
      Width           =   1935
   End
   Begin MSCommLib.MSComm SerialPort 
      Left            =   120
      Top             =   1680
      _Version        =   65536
      _ExtentX        =   847
      _ExtentY        =   847
      _StockProps     =   0
      CDTimeout       =   0
      CommPort        =   1
      CTSTimeout      =   0
      DSRTimeout      =   0
      DTREnable       =   0   'False
      Handshaking     =   0
      InBufferSize    =   1024
      InputLen        =   1
      Interval        =   1000
      NullDiscard     =   0   'False
      OutBufferSize   =   512
      ParityReplace   =   "?"
      RThreshold      =   1
      RTSEnable       =   0   'False
      Settings        =   "9600,n,8,1"
      SThreshold      =   0
   End
End
Attribute VB_Name = "Form1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
'
' Version 1.02 av BasicTX - 991230 by HTH
'
' This minimal example shows how to send a S.N.A.P packet on the serialport.
'
' Experienced programmers that want to take full advantage of the SNAP.DLL
' and implement functions like statistics, spying on other network traffic
' etc. see other examples in the ZIP-file.
'
' You can download the complete protocol description in PDF-format at
' the following URL...
'
'   http://www.hth.com/snap/
'
' More information about PLM-24 Power Line Modem and related products
' is available at...
'
'   http://www.hth.com/plm-24/
'
' Feel free to e-mail us any comments at info@hth.com. Due to the amount
' of e-mails we receive we are not always able to reply to you personally
' but all comments about the DLL or S.N.A.P network protocol in general
' are read and all feedback is appreciated!
'
' Disclaimer
' ----------
'
' This is released as "AS IS" and we are not able to provide any free
' support.
'
' Copyright (c) 1999 HTH all rights reserved
'
' Visual Basic 4.00
'
' External OCX/DLL files
'
' Name         Version       Maker
' ------------------------------------
' MSCOMM32.OCX  1.00        Microsoft
' SNAP.DLL      1.10        Harry Zachrisson, HTH
'

'Declaration
Private Declare Sub SetMyAddress Lib "snap.dll" (ByVal Address As Integer)
Private Declare Function SendData Lib "snap.dll" (TXData As Type_TXData) As Boolean
Private Declare Function GetTXPacket Lib "snap.dll" (Packet As Type_Packet) As Boolean

'Constants
Const MAXDATASIZE = 512
Const MAXPACKSIZE = 1042

'Declaration of a DataBytes structure
Private Type Type_DataBytes
    Byt(1 To MAXDATASIZE) As Byte
End Type

'Declaration of a PacketBytes structure
Private Type Type_PacketBytes
    Byt(1 To MAXPACKSIZE) As Byte
End Type

'Declaration of a Packet structure
'This is the encoded packet from the S.N.A.P encoder (GetTXPacket)
Private Type Type_Packet
    NumOfBytes As Integer
    PacketBytes As Type_PacketBytes
    Time As Date
End Type

'Declaration of a TXData structure
'This is the data that you want to send to a specified node (SendData)
Private Type Type_TXData
    DestAdd As Long             '-1=No Destination address was used. 0=Broadcast
    Data As Type_DataBytes      'Data
    NumOfDataBytes As Integer   'How many bytes in the Data array that is used
    ErrorMode As Byte           'The Errordetection mode do you want to use.
    Ack As Byte                 'Sets and gets ACK bits 0-3
    Cmd As Byte                 'Sets command mode bit
End Type

'Variables
Dim Tx As Type_TXData
Dim Data As Type_DataBytes
Dim Packet As Type_Packet

Private Sub CmdSend_Click()

    'Set DB1
    Tx.Data.Byt(1) = 255

    'Assign destination address.-1=No Destination address is used. 0=Broadcast
    Tx.DestAdd = 3
    
    'Set how many bytes in the data array that is used, this example only use 1 data byte
    Tx.NumOfDataBytes = 1
    
    'Set the error detection method do you want to use, this example use 16-bit CRC
    Tx.ErrorMode = 4
    
    'Decide if the receiving node shall return a ACK/NAK packet (0=No ACK/NAK, 1=ACK/NAK)
    Tx.Ack = 1
    
    'Decide if the command mode should be disabled/enabled (0=Command mode disabled, 1=Command mode enabled)
    Tx.Cmd = 0

    'Send data to DLL for encoding and place the packet in the outbuffer
    NotFull = SendData(Tx)
    
End Sub

Private Sub Form_Load()

    'Enable error trap for comport
    On Error GoTo Porterror
    
    'Settings for comport
    SerialPort.CommPort = 1                'Change if needed
    SerialPort.Settings = "2400,N,8,1"     '300 - 2400 bps for PLM-24
    SerialPort.Handshaking = 0
    SerialPort.InputLen = 1
    SerialPort.RThreshold = 1
    SerialPort.DTREnable = False
    SerialPort.RTSEnable = False
    SerialPort.PortOpen = True
    
    'Assign source address
    SetMyAddress 1
    
    Exit Sub
    
Porterror:
    'Comport error handler
    Const ERR_DEVICEUNAVAILABLE = 68
    If (Err = ERR_DEVICEUNAVAILABLE) Then
        Msg = "No contact with COM-Port " & Str(SerialPort.CommPort)
        MsgBox Msg, 48
        Exit Sub
    Else
        Msg = "Unexpected error #" & Str(Err) & " occured: " & Error
        MsgBox Msg, 16
        Stop
    End If
    Resume
End Sub

Private Sub Form_Unload(Cancel As Integer)
    SerialPort.PortOpen = False
    End
End Sub

Private Sub TxTimer_Timer()

    'This timer polls the outbuffer in SNAP.DLL. If there is any
    'encoded S.N.A.P packets available it call the TransmittData
    'routine and send it. It will continue to do so until the outbuffer
    'is empty.
    
    While GetTXPacket(Packet)
        'Disable timer so no more events can be generated until
        'the pending packets are transmitted
        TxTimer.Enabled = False
    
        'Transmitt encoded S.N.A.P packet
        For L = 1 To Packet.NumOfBytes
        'Give time to OS so it can process other events, important if
        'you are sending large S.N.A.P packets.
        x% = DoEvents()
        'Send packet
        SerialPort.Output = Chr$(Packet.PacketBytes.Byt(L))
    Next L
    
     Wend
     
     'Enable time so new events can be generated
     TxTimer.Enabled = True
     
End Sub


