library SNAP;
{-----------------------------------------------------------------------------}
{  S.N.A.P. WINDOWS 32 DLL BY  HARRY ZACHRISSON                               }
{                                                                             }
{  FOR SNAP VER. 1.1                                                          }
{                                                                             }
{  CREATED        981220                                                      }
{  LAST MODYFIED  000213                                                      }
{                                                                             }
{-----------------------------------------------------------------------------}


{-----------------------------------------------------------------------------}
{  ToDo                                                                       }
{                                                                             }
{                                                                             }
{                                                                             }
{-----------------------------------------------------------------------------}

{-----------------------------------------------------------------------------}
{  Known limitations                                                          }
{                                                                             }
{  2: ACK/NACK returns are passed to application layer                        }
{     (We have provided EDM byte to be passed up to the application so that   }
{      the application may do retransmission in case of NAK or timeouts)      }
{  3: If TXBuffert fills up during a 3 times retransmitt there will never be  }
{     sent 3 packets.                                                         }
{-----------------------------------------------------------------------------}

uses
  Classes,
  SysUtils,Windows;

{$R *.RES}

Type
  Type_Version= Record
                  Major  :Byte;
                  Minor  :Byte;
                End;

CONST
  VERSION:Type_Version=(Major:1;
                        Minor:01);

  TableCRC8 : Array[0..255] of Byte = (
    0, 94, 188,226, 97, 63, 221,131,194,156,126, 32, 163,253, 31, 65,
    157,195, 33, 127,252,162, 64, 30, 95, 1, 227,189, 62, 96, 130,220,
    35, 125,159,193, 66, 28, 254,160,225,191, 93, 3, 128,222, 60, 98,
    190,224, 2, 92, 223,129, 99, 61, 124, 34, 192,158, 29, 67, 161,255,
    70, 24, 250,164, 39, 121,155,197,132,218, 56, 102,229,187, 89, 7,
    219,133,103, 57, 186,228, 6, 88, 25, 71, 165,251,120, 38, 196,154,
    101, 59, 217,135, 4, 90, 184,230,167,249, 27, 69, 198,152,122, 36,
    248,166, 68, 26, 153,199, 37, 123, 58, 100,134,216, 91, 5, 231,185,
    140,210, 48, 110,237,179, 81, 15, 78, 16, 242,172, 47, 113,147,205,
    17, 79, 173,243,112, 46, 204,146,211,141,111, 49, 178,236, 14, 80,
    175,241, 19, 77, 206,144,114, 44, 109, 51, 209,143, 12, 82, 176,238,
    50, 108,142,208, 83, 13, 239,177,240,174, 76, 18, 145,207, 45, 115,
    202,148,118, 40, 171,245, 23, 73, 8, 86, 180,234,105, 55, 213,139,
    87, 9, 235,181, 54, 104,138,212,149,203, 41, 119,244,170, 72, 22,
    233,183, 85, 11, 136,214, 52, 106, 43, 117,151,201, 74, 20, 246,168,
    116, 42, 200,150, 21, 75, 169,247,182,232, 10, 84, 215,137,107, 53);

  TableCRC32 :  Array[0..255] of DWord = (
    $00000000, $77073096, $EE0E612C, $990951BA,
    $076DC419, $706AF48F, $E963A535, $9E6495A3,
    $0EDB8832, $79DCB8A4, $E0D5E91E, $97D2D988,
    $09B64C2B, $7EB17CBD, $E7B82D07, $90BF1D91,
    $1DB71064, $6AB020F2, $F3B97148, $84BE41DE,
    $1ADAD47D, $6DDDE4EB, $F4D4B551, $83D385C7,
    $136C9856, $646BA8C0, $FD62F97A, $8A65C9EC,
    $14015C4F, $63066CD9, $FA0F3D63, $8D080DF5,
    $3B6E20C8, $4C69105E, $D56041E4, $A2677172,
    $3C03E4D1, $4B04D447, $D20D85FD, $A50AB56B,
    $35B5A8FA, $42B2986C, $DBBBC9D6, $ACBCF940,
    $32D86CE3, $45DF5C75, $DCD60DCF, $ABD13D59,
    $26D930AC, $51DE003A, $C8D75180, $BFD06116,
    $21B4F4B5, $56B3C423, $CFBA9599, $B8BDA50F,
    $2802B89E, $5F058808, $C60CD9B2, $B10BE924,
    $2F6F7C87, $58684C11, $C1611DAB, $B6662D3D,

    $76DC4190, $01DB7106, $98D220BC, $EFD5102A,
    $71B18589, $06B6B51F, $9FBFE4A5, $E8B8D433,
    $7807C9A2, $0F00F934, $9609A88E, $E10E9818,
    $7F6A0DBB, $086D3D2D, $91646C97, $E6635C01,
    $6B6B51F4, $1C6C6162, $856530D8, $F262004E,
    $6C0695ED, $1B01A57B, $8208F4C1, $F50FC457,
    $65B0D9C6, $12B7E950, $8BBEB8EA, $FCB9887C,
    $62DD1DDF, $15DA2D49, $8CD37CF3, $FBD44C65,
    $4DB26158, $3AB551CE, $A3BC0074, $D4BB30E2,
    $4ADFA541, $3DD895D7, $A4D1C46D, $D3D6F4FB,
    $4369E96A, $346ED9FC, $AD678846, $DA60B8D0,
    $44042D73, $33031DE5, $AA0A4C5F, $DD0D7CC9,
    $5005713C, $270241AA, $BE0B1010, $C90C2086,
    $5768B525, $206F85B3, $B966D409, $CE61E49F,
    $5EDEF90E, $29D9C998, $B0D09822, $C7D7A8B4,
    $59B33D17, $2EB40D81, $B7BD5C3B, $C0BA6CAD,

    $EDB88320, $9ABFB3B6, $03B6E20C, $74B1D29A,
    $EAD54739, $9DD277AF, $04DB2615, $73DC1683,
    $E3630B12, $94643B84, $0D6D6A3E, $7A6A5AA8,
    $E40ECF0B, $9309FF9D, $0A00AE27, $7D079EB1,
    $F00F9344, $8708A3D2, $1E01F268, $6906C2FE,
    $F762575D, $806567CB, $196C3671, $6E6B06E7,
    $FED41B76, $89D32BE0, $10DA7A5A, $67DD4ACC,
    $F9B9DF6F, $8EBEEFF9, $17B7BE43, $60B08ED5,
    $D6D6A3E8, $A1D1937E, $38D8C2C4, $4FDFF252,
    $D1BB67F1, $A6BC5767, $3FB506DD, $48B2364B,
    $D80D2BDA, $AF0A1B4C, $36034AF6, $41047A60,
    $DF60EFC3, $A867DF55, $316E8EEF, $4669BE79,
    $CB61B38C, $BC66831A, $256FD2A0, $5268E236,
    $CC0C7795, $BB0B4703, $220216B9, $5505262F,
    $C5BA3BBE, $B2BD0B28, $2BB45A92, $5CB36A04,
    $C2D7FFA7, $B5D0CF31, $2CD99E8B, $5BDEAE1D,

    $9B64C2B0, $EC63F226, $756AA39C, $026D930A,
    $9C0906A9, $EB0E363F, $72076785, $05005713,
    $95BF4A82, $E2B87A14, $7BB12BAE, $0CB61B38,
    $92D28E9B, $E5D5BE0D, $7CDCEFB7, $0BDBDF21,
    $86D3D2D4, $F1D4E242, $68DDB3F8, $1FDA836E,
    $81BE16CD, $F6B9265B, $6FB077E1, $18B74777,
    $88085AE6, $FF0F6A70, $66063BCA, $11010B5C,
    $8F659EFF, $F862AE69, $616BFFD3, $166CCF45,
    $A00AE278, $D70DD2EE, $4E048354, $3903B3C2,
    $A7672661, $D06016F7, $4969474D, $3E6E77DB,
    $AED16A4A, $D9D65ADC, $40DF0B66, $37D83BF0,
    $A9BCAE53, $DEBB9EC5, $47B2CF7F, $30B5FFE9,
    $BDBDF21C, $CABAC28A, $53B39330, $24B4A3A6,
    $BAD03605, $CDD70693, $54DE5729, $23D967BF,
    $B3667A2E, $C4614AB8, $5D681B02, $2A6F2B94,
    $B40BBE37, $C30C8EA1, $5A05DF1B, $2D02EF8D);

  EXPIRYYEAR: Word=2000;
  EXPIRYMONTH:Word=4;
  SYNCSIZE=1;
  {Define maxsize in bytes of different portions of the protocoll}
  MAXADDRESSSIZE=3;
  MAXPFBFLAGS=3;
  MAXUFBFLAGS=3;
  MAXDATASIZE=512;
  MAXEDMSIZE=4;
  {Maximum packet size is sum of all max portions}
  {MAXPACKSIZE=SYNCSIZE+MAXDATASIZE+MAXPFBFLAGS+MAXUFBFLAGS+
               MAXADDRESSSIZE+MAXADDRESSSIZE+MAXDATASIZE+MAXEDMSIZE;}
  MAXPACKSIZE=1042;
  SYNC=84;
  ACK:Byte=0;
  NAK:Byte=1;

  PACKBUFFSIZE=50;
  RX=1;
  TX=2;
  SPY=3;

Type
  Type_Statistics=Record
                    RejectedPackets:LongInt;
                    TransmittedPackets:LongInt;
                    ReceivedPackets:LongInt;
                    TotalPackets:LongInt;
                    RejectedBytes:LongInt;
                    TransmittedBytes:LongInt;
                    ReceivedBytes:LongInt;
                    TotalBytes:LongInt;
                    StartTime:TDateTime;
                  End;

  Type_NumOfBytes=Array [0..3] of Word;
  Type_NumOfErrorBytes=Array [0..7] of Word;
  Type_NumOfDataBytes=Array [0..15] of Word;
  Type_HeaderDef = Record
                     DAB,SAB,PFB,ACK,CMD,EDM,NDB :Byte;
                   End;

  Type_ByteBuff=Array [1..MAXPACKSIZE] of Byte;

  Type_DataBytes= Array [1..MAXDATASIZE]of Byte; {Un/decoded data from or to DLL from App.}
  Type_PacketBytes= Array [1..MAXPACKSIZE]of Byte; {SNAP Packetbytes from or to Comlayer }

  Type_Packet = Record
                  NumOfBytes:SmallInt;           {Number of bytes in packet}
                  PacketBytes:Type_PacketBytes;  {All bytes in packet execept leading preamble bytes}
                  Time:TDateTime;                {Time stamp}
                End;

  Type_RXData = Record
                  DestAdd:LongInt;         {-1=No Destination address was used. 0=Broadcast}
                  SourceAdd:LongInt;       {-1=No Source address was used. 0=Broadcast}
                  Data:Type_DataBytes;     {All databytes}
                  NumOfDataBytes:SmallInt; {0-MAXDATASIZE}
                  EDMBits:Byte;            {only bits 0-3 is used}
                  ACKBits:Byte;            {only bits 0-3 is used}
                  CMDBit:Byte;
                  RXTime:TDateTime;        {Time stamp}
                End;

   Type_TXData = Record
                   DestAdd:LongInt;         {-1=No Destination address will be used. 0=Broadcast}
                   Data:Type_DataBytes;     {All databytes}
                   NumOfDataBytes:SmallInt; {0-MAXDATASIZE}
                   ErrorMode:Byte;          {Errordetection mode}
                   Ack:Byte;                {ACK Bits}
                   Cmd:Byte;                {CMD Bit (Lowest bit in Byte)}
                 End;


  Type_PackBuff = Array [1..PACKBUFFSIZE] of Type_Packet;     {PacketBuffert}
  Type_BuffPointers=Array[RX..SPY] of integer; {Pointers to buffert}

CONST
  NUMOFBYTESDAB:Type_NumOfBytes=(0,1,2,3); {DAB bytesize table}
  NUMOFBYTESSAB:Type_NumOfBytes=(0,1,2,3); {SAB bytesize table}
  NUMOFBYTESPFB:Type_NumOfBytes=(0,1,2,3); {PFB bytesize table}
  NUMOFBYTESUFB:Type_NumOfBytes=(0,1,2,3); {UFB bytesize table}
  NUMOFBYTESEDM:Type_NumOfErrorBytes=(0,0,1,1,2,4,0,0); {EDM bytesize table (No,Retran,Checksum8,CRC8,CRC16,CRC32,FEC,USER}
  NUMOFBYTESNDB:Type_NumOfDataBytes=(0,1,2,3,4,5,6,7,8,16,32,64,128,256,512,0); {SAB bytesize table}

VAR
  Expire:TDateTime;               {Holds Expiry date}
  Statistics:Type_Statistics;     {Stat. counters}
  GlobalMyAddress: LongInt;       {Listening address}

  RXByteBuff :Type_ByteBuff;      {Buffert of incoming bytes before the hole packet is in}
  RXNextP:Word;                   {Pointer of where to put next incoming byte in RXByteBuff}
  RXPackLength:Word;              {Packetlength as calculated from the headerbytes in the RX routine}
  FoundStart: Boolean;            {RX routine found a SYNCH byte}

  DebugMode:Boolean;              {Print debug info to file if True}

  PacketBuffer:Array [RX..SPY] of Type_PackBuff; {create Packetbufferts}
  CheckInPointer,CheckOutPointer:Type_BuffPointers;



{-------------------------------- misc. routines ------------------------------}


{Write debug info to a textfile}
Procedure DebugLog (Section,Info:String;Value:LongInt);
Var
  DebugFile:TextFile; {Debug file}
Begin
  If DebugMode Then Begin
  {$I-}
    Assign (DebugFile,'Debug.log');
    Append (DebugFile);
    If IOResult<>0 then REWrite (DebugFile);
    Writeln (DebugFile,'Section:',Section,' ',Info,' ',Value);
    close (DebugFile);
  {$I+}
  end;{If}
End; {proc}


{Check if DLL file is past its experation date }
Function OutDated :Boolean;
Begin
  OutDated:=False;
  If Now>Expire then OutDated:=True;
End;


{Turn on or off printing of debug info to a textfile}
Procedure SetDebugMode (Debug:WordBool) stdcall ;
Begin
  {If OutDated Then exit;}
  If Debug then
    Begin
    DebugMode:=Debug;
    DebugLog ('SetDebugMode','ON',0);
    end
  Else
    begin
    DebugLog ('SetDebugMode','OFF',0);
    DebugMode:=Debug;
  end
END;

{returns the expiry date}
Function ExpiryDate:TDateTime;  stdcall;
Begin
  ExpiryDate:=Expire;
  DebugLog ('ExpiryDate, ExpiryDate=','DateToString(Expire)',0);
END;


{Return DLL version to Application}
Function DLLVersion:Type_Version;  stdcall;
Begin
  DLLVersion:=VERSION;
  DebugLog ('DLLVersion','Major=',Version.Major);
  DebugLog ('DLLVersion','Minor=',Version.Minor);
END;

{Sets the address on this node}
Procedure SetMyAddress (MyAddress:LongInt) stdcall ;
Begin
  {If OutDated Then exit;}
  If MyAddress<-1 then MyAddress:=-1;
  If MyAddress>$FFFFFF then MyAddress:=$FFFFFF;
  GlobalMyAddress:=MyAddress;
  DebugLog ('SetMyAdress','MyAdress=',MyAddress);
END;

{return my node address}
Function MyAddress :LongInt stdcall ;
Begin
  MyAddress:=GlobalMyAddress;
  DebugLog ('MyAdress','MyAdress=',GlobalMyAddress);
END;

{Return statistics counters}
Procedure GetStatistics (VAR Stat:Type_Statistics) stdcall;
Begin
  {If OutDated Then exit;}
  Stat:=Statistics;
End;

{Set all statcounters to zero}
Procedure ClearStatistics  stdcall;
Begin
  Statistics.RejectedPackets:=0;
  Statistics.TransmittedPackets:=0;
  Statistics.ReceivedPackets:=0;
  Statistics.TotalPackets:=0;
  Statistics.RejectedBytes:=0;
  Statistics.TransmittedBytes:=0;
  Statistics.ReceivedBytes:=0;
  Statistics.TotalBytes:=0;
  Statistics.StartTime:=Now;
End;


{---------------- Header calculation and conversion routines ------------------}

Procedure DecodeHeader (HDB2,HDB1 :Byte; VAR Header:Type_HeaderDef);
Begin
  Header.DAB:= HDB2 AND (192) DIV 64;
  Header.SAB:= HDB2 AND (48) DIV 16;
  Header.PFB:= HDB2 AND (12) DIV 4;
  Header.ACK:= HDB2 AND (3) ;

  Header.CMD:=((HDB1 AND 128 ) DIV 128);
  Header.EDM:= HDB1 AND (112) DIV 16;
  Header.NDB:= HDB1 AND (15);
  DebugLog ('DecodeHeader','DAB=',Header.DAB);
  DebugLog ('DecodeHeader','SAB=',Header.SAB);
  DebugLog ('DecodeHeader','PFB=',Header.PFB);
  DebugLog ('DecodeHeader','ACK=',Header.ACK);
  DebugLog ('DecodeHeader','CMD=',Header.CMD);
  DebugLog ('DecodeHeader','EDM=',Header.EDM);
  DebugLog ('DecodeHeader','NDB=',Header.NDB);
END;

Procedure EncodeHeader (Header:Type_HeaderDef; VAR HDB2:Byte; VAR HDB1:Byte);
Begin
  HDB2:=0;
  HDB1:=0;
  HDB2:=HDB2 + Header.DAB SHL 6;
  HDB2:=HDB2 + Header.SAB SHL 4;
  HDB2:=HDB2 + Header.PFB SHL 2;
  HDB2:=HDB2 + Header.ACK ;

  HDB1:=HDB1 + Header.CMD SHL 7;
  HDB1:=HDB1 + Header.EDM SHL 4;
  HDB1:=HDB1 + Header.NDB;
  DebugLog ('EncodeHeader','HDB2=',HDB2);
  DebugLog ('EncodeHeader','HDB1=',HDB1);
END;


Function PacketSize (HDB2,HDB1 :Byte): SmallInt; {dont include SYNCH in calculation}
VAR
  Header:Type_HeaderDef;
  TempSize: Word;
Begin
  TempSize:=0;
  DecodeHeader (HDB2,HDB1,Header);
  Inc (TempSize,3); {Sync+Header}
  Inc (TempSize,NUMOFBYTESDAB[Header.DAB]);
  Inc (TempSize,NUMOFBYTESSAB[Header.SAB]);
  Inc (TempSize,NUMOFBYTESPFB[Header.PFB]);
  Inc (TempSize,NUMOFBYTESEDM[Header.EDM]);
  Inc (TempSize,NUMOFBYTESNDB[Header.NDB]);
  PacketSize:=TempSize;
  DebugLog ('PacketSize','Size=',TempSize);
End;


Function DestinationAddress (Packet:Type_Packet):LongInt;
VAR
  Header:Type_HeaderDef;
Begin
  DestinationAddress:=0;
  DecodeHeader (Packet.PacketBytes[2],Packet.PacketBytes[3],Header);
  DebugLog ('DestinationAddress','Header.DAB=',Header.DAB);
  Case Header.DAB of   {Calculate how many DAB Bytes is needed. 0 is a special value indicating that no Destination adress was sent}
    0:
      Begin
        DestinationAddress:=-1;{Missing Destination address}
      End;
    1:
      Begin
        DestinationAddress:=Packet.PacketBytes[4];
      End;
    2:
      Begin
        DestinationAddress:=(Packet.PacketBytes[4] * $100)
                           + Packet.PacketBytes[5];
      End;
    3:
      Begin
        DestinationAddress:=(Packet.PacketBytes[4] * $10000)
                          + (Packet.PacketBytes[5] * $100)
                           + Packet.PacketBytes[6];
      End;
  End; {Case Header.DAB}
End; {DestinationAddress}


Function AddressedToMe (Packet:Type_Packet):Boolean ;
VAR
  Address:LongInt;
Begin
  Address:=DestinationAddress(Packet);
  AddressedToMe:=(Address=MyAddress) or (Address=0);
End;


{----------------------- error and CRC routines -------------------------------}


{general 8 Bit checksum}
Procedure  Sum8 (VAR Sum:Byte;InByte:Byte);
Begin
  Sum:=(Sum + Inbyte) AND $FF;
End;



{Dallas One wire 8 Bit Cyclic Redundency Check}
Procedure  CRC8 (VAR CRC8Val:Byte;InByte:Byte);
Begin
  CRC8VAl := TableCRC8[CRC8VAl xor InByte];
End;



{CITT 16 Bit Cyclic Redundency Check}
Procedure  CRC16 (VAR CRC16:Word;InByte:Byte);
CONST
  POLYNOM:word=$1021;
  HiBit=$8000;
VAR
  BitCount:Byte;
Begin
  CRC16:=(InByte*256) XOR CRC16;
  For BitCount :=0 to 7 Do Begin
    IF CRC16 and HiBit=HiBit Then Begin
       CRC16:=((CRC16 SHL 1) XOR POLYNOM) AND $FFFF;
      End
    Else BEGIN
      CRC16:=CRC16 SHL 1;
    End; {If}
  End; {For}
  DebugLog ('CRC16','CRC16=',CRC16);
End;


{32 Bit Cyclic Redundency Check (Ethernet standard)}
Procedure CRC32 (VAR CRC32Val:  DWord;InByte:Byte);
BEGIN
    CRC32Val := (CRC32Val SHR 8)  XOR TableCRC32[InByte XOR (CRC32Val AND $000000FF)];
END {CRC32};



Procedure CalcSum8 (Packet:Type_Packet; VAR SumB1:Byte);
Var
  ByteCount,PackSize:Word;
  SumByte:Byte;
Begin
  PackSize:=PacketSize(Packet.PacketBytes[2],Packet.PacketBytes[3]);
  SumByte:=0;
  For ByteCount:= 2 to PackSize-1 Do Begin {All bytes except SYNC and Checksumbyte}
    Sum8(SumByte,Packet.PacketBytes[ByteCount]);
  End;
  SumB1:=SumByte;
  DebugLog ('CalcSum8','SumByte=',SumByte);
End;


Procedure CalcCRC8 (Packet:Type_Packet; VAR CRCB1:Byte);
Var
  ByteCount,PackSize:Word;
  CRC:Byte;
Begin
  PackSize:=PacketSize(Packet.PacketBytes[2],Packet.PacketBytes[3]);
  CRC:=$00;{Set start value}
  For ByteCount:= 2 to PackSize-1 Do Begin {All bytes except SYNC and Checksumbyte}
    CRC8(CRC,Packet.PacketBytes[ByteCount]);
  End;
  CRCB1:=CRC;
  DebugLog ('CalcCRC8','CRC=',CRC);
End;


Procedure CalcCRC16 (Packet:Type_Packet;VAR CRCB2:Byte; VAR CRCB1:Byte);
Var
  ByteCount,PackSize:Word;
  CRCValue:Word;
Begin
  PackSize:=PacketSize(Packet.PacketBytes[2],Packet.PacketBytes[3]);
  CRCValue:=0;
  For ByteCount:= 2 to PackSize-2 Do Begin {All bytes except SYNC and Checksumbytes}
    CRC16(CRCValue,Packet.PacketBytes[ByteCount]);
  End;
  DebugLog ('CalcCRC16','CRC Value=',CRCValue);

  CRCB1:=CRCValue and $FF;
  CRCB2:=(CRCValue and $FF00) div $FF;
  DebugLog ('CalcCRC16','CRC Byte1=',CRCB1);
  DebugLog ('CalcCRC16','CRC Byte2=',CRCB2);
End;


Procedure CalcCRC32 (Packet:Type_Packet;VAR CRCB4:Byte; VAR CRCB3:Byte;VAR CRCB2:Byte; VAR CRCB1:Byte);
Var
  ByteCount,PackSize:Word;
  CRCValue:DWord;
Begin
  PackSize:=PacketSize(Packet.PacketBytes[2],Packet.PacketBytes[3]);
  CRCValue:=$FFFFFFFF;{Set start value}
  For ByteCount:= 2 to PackSize-4 Do Begin {All bytes except SYNC and Checksumbytes}
    CRC32(CRCValue,Packet.PacketBytes[ByteCount]);
  End;
  CRCValue:=NOT CRCValue;
    CRCB1:=CRCValue and $FF;
    CRCB2:=(CRCValue and $FF00) div $FF;
    CRCB3:=(CRCValue and $FF0000) div $FFFF;
    CRCB4:=(CRCValue and $FF000000) div $FFFFFF;
End;


{Test integrity of packet by calculating and comparing Checksum or CRC}
Function NoErrors (Packet:Type_Packet):Boolean;
Var
  Header:Type_HeaderDef;
  ErrB1,ErrB2,ErrB3,ErrB4:Byte;
Begin
  DecodeHeader(Packet.PacketBytes[2],Packet.PacketBytes[3],Header);
  Case Header.EDM of
    2:Begin
        CalcSum8 (Packet,ErrB1);
        {Compare last byte in packet (checksumbyte) with calculated checksum}
        NoErrors:=(Packet.PacketBytes[Packet.NumOfBytes]=ErrB1);
        DebugLog('NoErrors,Sum8Test','ErrB1=',ErrB1);
      end;
    3:Begin
        CalcCRC8 (Packet,ErrB1);
        {Compare last byte in packet (CRCbyte) with calculated CRC}
        NoErrors:=(Packet.PacketBytes[Packet.NumOfBytes]=ErrB1);
        DebugLog('NoErrors,CRC8Test','ErrB1=',ErrB1);
      end;
    4:Begin
        CalcCRC16 (Packet,ErrB2,ErrB1);
        {Compare last bytes in packet (CRCbytes) with calculated CRC}
        NoErrors:=(Packet.PacketBytes[Packet.NumOfBytes]=ErrB1) AND
                    (Packet.PacketBytes[Packet.NumOfBytes-1]=ErrB2);
        DebugLog('NoErrors,CRC16Test','ErrB1=',ErrB1);
        DebugLog('NoErrors,CRC16Test','ErrB2=',ErrB2);
      end;
    5:Begin
        CalcCRC32 (Packet,ErrB4,ErrB3,ErrB2,ErrB1);
        {Compare last bytes in packet (CRCbytes) with calculated CRC}
        NoErrors:=(Packet.PacketBytes[Packet.NumOfBytes]=ErrB1) AND
                    (Packet.PacketBytes[Packet.NumOfBytes-1]=ErrB2) AND
                    (Packet.PacketBytes[Packet.NumOfBytes-2]=ErrB3) AND
                    (Packet.PacketBytes[Packet.NumOfBytes-3]=ErrB4);
          DebugLog('NoErrors,CRC32Test','ErrB1=',ErrB1);
          DebugLog('NoErrors,CRC32Test','ErrB2=',ErrB2);
          DebugLog('NoErrors,CRC32Test','ErrB3=',ErrB3);
          DebugLog('NoErrors,CRC32Test','ErrB4=',ErrB4);
      end;
  Else  {No error detection bytes where used, set ErrorCheck to True}
    NoErrors:=True;
  End;
End;


Procedure WriteErrorBytes (VAR Packet:Type_Packet); {Calculate and add Checksum or CRC bytes}
Var
  Header:Type_HeaderDef;
  ErrB1,ErrB2,ErrB3,ErrB4:Byte;
Begin
  DecodeHeader(Packet.PacketBytes[2],Packet.PacketBytes[3],Header);
  Case Header.EDM of
    2:Begin
        CalcSum8 (Packet,ErrB1);
        Packet.PacketBytes[Packet.NumOfBytes]:=ErrB1;
      end;
    3:Begin
        CalcCRC8 (Packet,ErrB1);
        Packet.PacketBytes[Packet.NumOfBytes]:=ErrB1;
      end;
    4:Begin
        DebugLog ('WriteErrorBytes','BeforeCRC16',0);
        CalcCRC16 (Packet,ErrB2,ErrB1);
        DebugLog ('WriteErrorBytes','CRC16 ErrB1=',ErrB1);
        DebugLog ('WriteErrorBytes','CRC16 ErrB2=',ErrB2);
        Packet.PacketBytes[Packet.NumOfBytes]:=ErrB1;
        Packet.PacketBytes[Packet.NumOfBytes-1]:=ErrB2;
      end;
    5:Begin
        CalcCRC32 (Packet,ErrB4,ErrB3,ErrB2,ErrB1);
        Packet.PacketBytes[Packet.NumOfBytes]:=ErrB1;
        Packet.PacketBytes[Packet.NumOfBytes-1]:=ErrB2;
        Packet.PacketBytes[Packet.NumOfBytes-2]:=ErrB3;
        Packet.PacketBytes[Packet.NumOfBytes-3]:=ErrB4;
      end;
  End;
End;



{-------------------------------- PacketBuffert routines ---------------------------------}


{Increment a BufferPointer}
Procedure IncPointer (VAR InPointer:integer);
Begin
 IF InPointer=PACKBUFFSIZE Then  {If reached end, go round}
   Begin
     InPointer:=1;
   End
 Else
   Begin
     Inc (InPointer);
 End
End;


{Calculate the number of packet in a buffer}
Function NumOfPackets(Buffer:Integer):Integer;
Begin
  If CheckInPointer[Buffer]<CheckOutPointer[Buffer] then  {CheckIn has rounded but not CheckOut}
    Begin
      NumOfPackets:=(CheckInPointer[Buffer]+PACKBUFFSIZE)-CheckOutPointer[Buffer];
    End
  Else
    Begin
      NumOfPackets:=CheckInPointer[Buffer]-CheckOutPointer[Buffer];
  End;
End;

{Take out a packet from a buffert, False=Empty}
Function CheckOutPacket (VAR OutPacket:Type_Packet;FromBuffer:Integer):Boolean;
Begin
  IF NumOfPackets(FromBuffer)>0 then  {Test if any packets in buffer}
    Begin
      DebugLog ('CheckOutPacket','CheckOutPointer=',CheckOutPointer[FromBuffer]);
      OutPacket:=PacketBuffer[FromBuffer][CheckOutPointer[FromBuffer]];
      IncPointer (CheckOutPointer[FromBuffer]); {erase packet from buffer}
      CheckOutPacket:=True;
      DebugLog ('CheckOutPacket,Packet.Time=',TimeToStr(OutPacket.Time),CheckOutPointer[FromBuffer]);
    End
  Else
    Begin    {Buffer is empty}
      DebugLog ('CheckOutPacket,Buffer is empty','1=Rx, 2=TX, 3=SPY',FromBuffer);
      CheckOutPacket:=False;
  End;
End;{CheckOutPacket}


{Input a new packet to a buffert, False=Full}
Function CheckInPacket (InPacket:Type_Packet;ToBuffer:Integer):Boolean;
Begin
  IF NumOfPackets(ToBuffer)<PACKBUFFSIZE then  {Test not to overrun buffer}
    Begin
      DebugLog ('CheckInPacket','CheckInPointer=',CheckInPointer[ToBuffer]);
      PacketBuffer[ToBuffer][CheckInPointer[ToBuffer]]:=InPacket;
      IncPointer (CheckInPointer[ToBuffer]); {prepare for next packet}
      CheckInPacket:=True;
    End
  Else
    Begin    {Buffer is full}
      DebugLog ('CheckInPacket, ************** BUFFER IS FULL ***********','1=Rx, 2=TX, 3=SPY',ToBuffer);
      CheckInPacket:=False;
  End;
End;{CheckInPacket}


{Do all the CRC,Address test etc.. and save it in RXPacketbuffert (Endstation of indata)}
Function SaveRXPacket (Packet:Type_Packet):WordBool;
Begin
  SaveRXPacket:=True;{Can only be false if validpacket can't be checked in}
  IF NoErrors (Packet) Then {Test for CRC errors}
    Begin
      DebugLog ('SaveRXPacket','Passed errorCheck',0);
      Packet.Time:=Now;
      CheckInPacket(Packet,SPY); {Save a copy in SPY PacketBuffer, ignore overruns}
      If AddressedToMe (Packet) Then {Se if it's for me}
        Begin
        SaveRXPacket:=CheckinPacket (Packet,RX);{Save and indicate fullbuffert}
        Inc (Statistics.ReceivedPackets);
        Inc (Statistics.TotalPackets);
        Inc (Statistics.ReceivedBytes,Packet.NumOfBytes);
        End
      Else
        Begin
        Inc (Statistics.TotalPackets);
        DebugLog ('SaveRXPacket','*Not my address',0);
      End;{If AddressedToMe}
    End
  Else
    Begin
      Packet.NumOfBytes:=0; {Bad packet, Erase it}
      Inc(Statistics.RejectedPackets);
      Inc (Statistics.TotalPackets);
      DebugLog ('SaveRXpacket','********* PACKET DID NOT PASS ERRORCHECK (CRC) **********',0);
  End;{If NoErrors}
End;



{-------------------------------- TX Routines ---------------------------------}
Function SendData(VAR TXData:Type_TXData) :WordBool stdcall ;

VAR
  Packet:Type_Packet;
  Header :Type_HeaderDef;
  DataLoop,NextByte :Word;
  Rest:LongInt;


Begin
  {SendData:=True; {Can only be false if full TXbuffert}
   {If OutDated Then exit;}
   If TXData.DestAdd<-1 then TXData.DestAdd:=-1;
   If TXData.DestAdd>$FFFFFF then TXData.DestAdd:=$FFFFFF;

   DebugLog ('SendData','Start',0);
   For Dataloop:=1 to 10 Do
    Begin
    DebugLog('SendData','DataBytes=',TXData.Data[DataLoop]);
  end;
   Case TXData.DestAdd of   {Calculate how many DAB Bytes is needed. -1 is a special value indicating that DAB=0}
     -1:
       Begin
         Header.DAB:=0; {Don't send any Destination address}
       End;
     0..$FF:
       Begin
         Header.DAB:=1;
       End;
     $100..$FFFF:
       Begin
         Header.DAB:=2;
       End;
     $10000..$FFFFFF:
       Begin
         Header.DAB:=3;
       End;
    End; {Case DestAdd}



     Case MyAddress of   {Calculate how many DSB Bytes is needed. -1 is a special value indicating that SAB=0}
     -1:
       Begin
         Header.SAB:=0; {Don't send any Destination address}
       End;
     0..$FF:
       Begin
         Header.SAB:=1;
       End;
     $100..$FFFF:
       Begin
         Header.SAB:=2;
       End;
     $10000..$FFFFFF:
       Begin
         Header.SAB:=3;
       End;
    End; {Case DestAdd}

  Header.PFB:=0;        {Not defined in version 1.0 of the SNAP protocol}
  Header.CMD:=TXData.Cmd and 1;
  Header.ACK:=TXData.Ack and 3;
  Header.EDM:=TXData.ErrorMode and 7;

  {Store number of data to send, if value is not a defined value then change it to the closest higher}
  If TXData.NumOfDataBytes>512 then TXData.NumOfDataBytes:=512;
  Case TXData.NumOfDataBytes of
    0..8 :   Begin
               Header.NDB:=TXData.NumOfDataBytes
             End;
    9..16 :  Begin
               Header.NDB:=9;
               TXData.NumOfDataBytes:=16;
             End;
    17..32  :Begin
               Header.NDB:=10;
               TXData.NumOfDataBytes:=32;
             End;
    33..64  :Begin
               Header.NDB:=11;
               TXData.NumOfDataBytes:=64;
             End;
    65..128 :Begin
               Header.NDB:=12;
               TXData.NumOfDataBytes:=128;
             End;
    129..256:Begin
               Header.NDB:=13;
               TXData.NumOfDataBytes:=256;
             End;
    257..512:Begin
               Header.NDB:=14;
               TXData.NumOfDataBytes:=512;
             End;

  {Value 15 can never be achevied as it is not defined in the SNAP protocoll yet.}

  end; {case}

  {Store SYNC }
  Packet.PacketBytes[1]:=SYNC;
  {Encode and save Header}
  EncodeHeader (Header,Packet.PacketBytes[2],Packet.PacketBytes[3]);
  {Save Packet Length.}
  Packet.NumOfBytes:=PacketSize(Packet.PacketBytes[2],Packet.PacketBytes[3]);
  NextByte:=4;

  {Save DAB Bytes}
  Case Header.DAB of
  3: Begin
       Packet.PacketBytes[NextByte]:=TXData.DestAdd DIV $10000;
       Inc (NextByte);
       Rest:=TXData.DestAdd Mod $10000;
       Packet.PacketBytes[NextByte]:=Rest DIV $100;
       Inc (NextByte);
       Rest:=Rest Mod $100;
       Packet.PacketBytes[NextByte]:=Rest;
       Inc (NextByte);
     End;
  2: Begin
       Packet.PacketBytes[NextByte]:=TXData.DestAdd DIV $100;
       Inc (NextByte);
       Packet.PacketBytes[NextByte]:=TXData.DestAdd Mod $100;
       Inc (NextByte);
     End;
  1: Begin
       Packet.PacketBytes[NextByte]:=TXData.DestAdd;
       Inc (NextByte);
     End;
  End;{Case}

  {Save SAB Bytes}
  Case Header.SAB of
    3: Begin
         Packet.PacketBytes[NextByte]:=Myaddress DIV $10000;
         Inc (NextByte);
         Rest:=Myaddress Mod $10000;
         Packet.PacketBytes[NextByte]:=Rest DIV $100;
         Inc (NextByte);
         Rest:=Rest Mod $100;
         Packet.PacketBytes[NextByte]:=Rest;
         Inc (NextByte);
       End;
    2: Begin
         Packet.PacketBytes[NextByte]:=Myaddress DIV $100;
         Inc (NextByte);
         Packet.PacketBytes[NextByte]:=Myaddress Mod $100;
         Inc (NextByte);
       End;
    1: Begin
         Packet.PacketBytes[NextByte]:=MyAddress;
         Inc (NextByte);
       End;
  End;{Case}

  {Save Data bytes}
  DebugLog ('SendData','TXData.NumOfDataBytes=',TXData.NumOfDataBytes);

  For DataLoop:=TXData.NumOfDataBytes downto 1 Do
    Begin
    DebugLog('SendData,SaveDataBytes','DataLoop=',DataLoop);
    DebugLog('SendData,SaveDataBytes','DataByte=',TXData.Data[DataLoop]);
    Packet.PacketBytes[NextByte]:=TXData.Data[DataLoop];
    Inc (NextByte);
  End;{If}

  WriteErrorBytes (Packet); {Add, checksum or CRC if EDM indicates it}

  For Dataloop:=1 to Packet.NumOfBytes Do
    Begin
    DebugLog('SendData','PacketBytes=',Packet.PacketBytes[DataLoop]);
  end;

   SendData:=CheckInPacket (Packet,TX); {Store packet in packet buffert for later transmision}

  IF Header.EDM= 1 then  {If tre times retransmit then make 2 more copies of packet}
    begin
      {IF TX Buffert is full at no. 2 then don't send no. 3}
      SendData:=CheckInPacket (Packet,TX) OR CheckInPacket (Packet,TX);
  end; {If}
End;


{Read back a TX packet }
Function GetTXPacket (VAR OutPacket:Type_Packet):WordBool stdcall;
VAR
  Packet:Type_Packet;
Begin
  GetTXPacket:=False;
  {If OutDated Then exit;}
  IF CheckOutPacket(Packet,TX) then
    Begin
    GetTXPacket:=True;
    {Timestamp (don't have a use in send routine, but uses this packet format for compability}
    Packet.Time:=Now;
    OutPacket:=Packet;
    CheckInPacket (Packet,SPY);  {Copy TX packet to SPY buffert now when it is going to be sent}
    DebugLog ('GetTXPacket','NumOfBytes=',Packet.NumOfBytes);
    Inc(Statistics.TransmittedBytes,Packet.NumOfBytes);
    Inc(Statistics.TotalBytes,Packet.NumOfBytes);
    Inc(Statistics.TransmittedPackets);
    Inc (Statistics.TotalPackets);
  End
End;

{------------------------------ RX routines -----------------------------------}

{Input Bytes to ByteBuffert}
Function RXByteIn (InByte:byte) :WordBool stdcall ;

    Function IfSynch(TestByte:Byte):Boolean;
    Begin
      IfSynch:=TestByte=SYNC;
    End;


    {Move bytes from ByteBuffert to Packet}

    Procedure TransferPacket;
    Var
      Packet:Type_Packet;
      ByteCounter:Word;
    Begin
      Packet.NumOfBytes:=RXPackLength;{Store length}

      For ByteCounter:= 1 To RXPackLength Do {transfer all bytes from ByteBuffer to the packet record}
        Begin
          DebugLog ('RXByteIn,TransferPacket','ByteCounter=',ByteCounter);
          DebugLog ('RXByteIn,TransferPacket','Byte=',RXByteBuff[ByteCounter]);
          Packet.PacketBytes[ByteCounter]:=RXByteBuff[ByteCounter];
          {TimeStamp}
          {Packet.Time:=Now;}
      End; {For}
      RXByteIn:=SaveRXPacket (Packet); {Save it in packetbuffer for later retrieval}
      {If RXPacketbuffer is full then indicate this so that linklayer can stop }
    End; {TransferPacket}


    Function Complete:Boolean;
    Begin
      Complete:=RXNextP=RXPackLength;
    End;


Begin
  {If OutDated Then
    Begin
    RXByteIn:=False;
    exit;
  End;}
  RXByteIn:=True;{Can only be false if RXBuffer is full when saving a complet packet}
  Inc (Statistics.TotalBytes);
  DebugLog ('RXByteIn','InByte=',InByte);
  RXByteBuff[RXNextP]:=InByte; {Store the byte in buffer}

  If Not FoundStart Then {If we haven't found the start of a packet yet just test the byte to se if its a SYNCH byte (SYNCH)}
    begin
    FoundStart:=IfSynch(RXByteBuff[RXNextP]); {Test the Byte to se if it is a SYNC}
    If Not FoundStart Then
      Begin              {This was not a SYNC byte so Packet has not started yet, erase the "junk" byte by not advancing the byte counter}
      Inc(Statistics.RejectedBytes);
       DebugLog ('RXByteIn','********* JUNK BYTE TOSSED **********',0);                   {Do nothing, just wait for the next byte to come in}
      End
    Else
      Begin             {This was the SYNCH Byte, remeber it. Henceforth we will store all bytes untill the end of packet }
      FoundStart:=True;
      Inc (RXNextP); {Point to next byte in the combufer}
    End
    End
  else
    begin
    Case RXNextP of
     1..2:               {Header isn't complete yet, wait for it to be}
       Begin
         Inc (RXNextP); {Point to next byte in the combufer}
       End;
     3:       {Header is in (2 bytes+SYNC=3), calculate and store the length of the packet}
       Begin
         RXPackLength:=PacketSize(RXByteBuff[2],RXByteBuff[3]); {Store PacketLength as calculated from the header}
         Inc (RXNextP); {Point to next byte in the combufer}
       End;
     4..MAXPACKSIZE:
       Begin
         IF Complete then  {If last byte is in then save it to PacketBuffer}
           Begin
           TransferPacket; {Packet is complete, transfer it to the RXPacketBuffer}
           RXNextP:=1; {Clear ByteBuffert counter to prepare for a new Packet }
           FoundStart:=False; {Start all over}
           End
         Else
           Begin     {All bytes not in yet}
           Inc (RXNextP); {Point to next byte in the combufer}
         End{If complete}
       End;
    End; {Case RXBytes}
  End; {IF NOT FoundStart}
End;


{Read a packet from a packetbuffert and converts it to Data }
Procedure PacketToData (Packet:Type_Packet;VAR Data:Type_RXData);

VAR
  Header :Type_HeaderDef;
  DataLoop,NextByte :Word;

Begin
    Data.RxTime:=Packet.Time;
    DecodeHeader (Packet.PacketBytes[2],Packet.PacketBytes[3],Header);
    NextByte:=4; {SYNC=1,HDB2=2,HDB1=3, Ergo.. NextByte=4}

    DebugLog ('PacketToData','Header.DAB=',Header.DAB);
    Case Header.DAB of   {Calculate how many DAB Bytes is needed. 0 is a special value indicating that no Destination adress was sent}
     0:
       Begin
         Data.DestAdd:=-1;{Missing Destination address}
       End;
     1:
       Begin
         Data.DestAdd:=Packet.PacketBytes[NextByte];
         Inc (NextByte,1);
       End;
     2:
       Begin
         Data.DestAdd:=(Packet.PacketBytes[NextByte] * $100)
                        + Packet.PacketBytes[NextByte+1];
         Inc (NextByte,2);
       End;
     3:
       Begin
          Data.DestAdd:=(Packet.PacketBytes[NextByte] * $10000)
                        + (Packet.PacketBytes[NextByte+1] * $100)
                         + Packet.PacketBytes[NextByte+2];
         Inc (NextByte,3);
       End;
     End; {Case DestAdd}

     DebugLog ('PacketToData','Header.SAB=',Header.SAB);
     Case Header.SAB of   {Calculate how many SAB Bytes is needed. 0 is a special value indicating that no Source adress was sent}
     0:
       Begin
         Data.SourceAdd:=-1;{Missing Source address}
       End;
     1:
       Begin
         Data.SourceAdd:=Packet.PacketBytes[NextByte]; {If 0 it was a broadcast}
         Inc (NextByte,1);
       End;
     2:
       Begin
         Data.SourceAdd:=(Packet.PacketBytes[NextByte] * $100)
                          + Packet.PacketBytes[NextByte+1];
         Inc (NextByte,2);
       End;
     3:
       Begin
          Data.SourceAdd:=(Packet.PacketBytes[NextByte] * $10000)
                          + (Packet.PacketBytes[NextByte+1] * $100)
                           + Packet.PacketBytes[NextByte+2];
         Inc (NextByte,3) ;
       End;
     End; {Case SourceAdd}

    { DebugLog ('PacketToData','Header.PFB=',Header.PFB);
     Data.FlagsUsed:=Header.PFB;
     Case Header.PFB of   {Calculate how many Protocollflag bytes was received}

  {   1:
       Begin
         Data.ProtoFlags[1]:=Packet.PacketBytes[NextByte];
         Inc (NextByte,1);
       End;
     2:
       Begin
         Data.ProtoFlags[1]:=Packet.PacketBytes[NextByte+1];
         Data.ProtoFlags[2]:=Packet.PacketBytes[NextByte];
         Inc (NextByte,2);
       End;
     3:
       Begin
         Data.ProtoFlags[1]:=Packet.PacketBytes[NextByte+2];
         Data.ProtoFlags[2]:=Packet.PacketBytes[NextByte+1];
         Data.ProtoFlags[3]:=Packet.PacketBytes[NextByte];
         Inc (NextByte,3);
       End;
     End; {Case SourceAdd}

    {Transfer Data bytes}
    IF Header.NDB>0 Then {If data}
      Begin
      For DataLoop:= NUMOFBYTESNDB[Header.NDB] downto 1 Do
        Begin
        DebugLog ('PacketToData','DataLoop=',DataLoop);
        DebugLog ('PacketToData','NextByte=',DataLoop);
        DebugLog ('PacketToData','Packet.PacketBytes[NextByte]=',Packet.PacketBytes[NextByte]);
        Data.Data[DataLoop]:=Packet.PacketBytes[NextByte];
        Inc (NextByte);
      End;{For}
    End; {If}

    Data.NumOfDataBytes:=NUMOFBYTESNDB[Header.NDB];
    DebugLog ('PacketToData','Data.NumOfDataBytes=',Data.NumOfDataBytes);
    DebugLog ('PacketToData','Header.EDM=',Header.EDM);
    Data.EDMBits:=Header.EDM;
    Data.ACKBits:=Header.ACK;
    Data.CMDBit:=Header.CMD;
End;


{Read a RX packet }
Function GetRXData (VAR RXData:Type_RXData):WordBool stdcall;
VAR
  Packet:Type_Packet;
Begin
  GetRXData:=False;
  {If OutDated Then exit;}
  IF CheckOutPacket (Packet,RX) then {If PacketBuffert is not empty}
    Begin
    {Packet retreived from RX Packetbuffer }
    GetRXData:=True;
    DebugLog ('GetRXData','Packet.NumOfBytes=',Packet.NumOfBytes);
    PacketToData (Packet,RXData)
    End
  Else
    Begin
    DebugLog ('GetRXData','GetRXData:=False (No packets in buffert)',0);
  End {IF NotEmpty}
End;


{Read a SPY packet }
Function GetSPYData (VAR RXData:Type_RXData):WordBool stdcall;
VAR
  Packet:Type_Packet;
Begin
  GetSPYData:=False;
  {If OutDated Then exit;}
  IF CheckOutPacket (Packet,SPY) then {If PacketBuffert is not empty}
    Begin
    {Packet retreived from RX Packetbuffer }
    GetSPYData:=True;
    DebugLog ('GetSPYData','Packet.NumOfBytes=',Packet.NumOfBytes);
    PacketToData (Packet,RXData)
    End
  Else
    Begin
    DebugLog ('GetSPYData','GetRXData:=False (No packets in buffert)',0);
  End {IF NotEmpty}
End;


Exports
  SetDebugMode Name 'SetDebugMode',

  ExpiryDate Name 'ExpiryDate',
  DLLVersion Name 'DLLVersion' ,

  SetMyAddress Name 'SetMyAddress' ,
  MyAddress Name 'MyAddress',

  GetStatistics Name 'GetStatistics',
  ClearStatistics Name 'ClearStatistics',

  SendData Name 'SendData',
  GetTXPacket Name 'GetTXPacket',

  RXByteIn Name 'RXByteIn' ,
  GetRXData Name 'GetRXData',
  GetSPYData Name 'GetSPYData';

begin
  Expire:=EncodeDate(EXPIRYYEAR, EXPIRYMONTH, 01);
  DebugMode:=False;
  FoundStart:=False;               {No SYNCH}
  RXPackLength:=0;                 {No Bytes in}
  RXNextP:=1;                      {Ready for first byte}
  
  CheckInPointer[RX]:=1;           {Clear Packet buffers}
  CheckOutPointer[RX]:=1;
  CheckInPointer[TX]:=1;
  CheckOutPointer[TX]:=1;
  CheckInPointer[SPY]:=1;
  CheckOutPointer[SPY]:=1;

  ClearStatistics;   {Clear all stat. counters}
end.

